{
  Yaskawan muuttaja:
  Asetukset muuttajassa muuttuvat vain, jos virta kytetn poissa!
    Rekisterien lukeminen (fkt 3): (ks Yaskawan IO-manu p 14/29)
      esim:              11-rekisteri (alk. 101H)
                  id fkt 10B  5-kpl   crc (lo-hi)
        lhet :  01 03 01 0B 00 05   F5 F7

                        rek  011  012   013  014    015
                        mem  10BH 10CH  10DH 10EH   10FH
                  id fkt #  230V,60 Hz, 230V,60 Hz,3.0 Hz,crc
        takaisin: 01 03 0A 08 FC 02 58 08 FC 02 58 00 1E FD 7B

    Jos funktio on vr, tulee takasin vastaus, jossa on
    id, 7-bit pll +fkt nro,  virhekoodi + crc

    Jotta tottelisi ajoksky PC:lt, aseta (fkt 10H) 002:een 6:
                  id fkt 102H lkm=1 tav
        lhet :  01 10 01 02 00 01 02  00 06


}

unit commf;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, OleCtrls, MSCOMM32;

type
  cLueRS = class(TThread)
  // Laskurisie perit.yleisest sikeest
  // ja siihen listn omat erikoispiirt.
  private
    LabelInHex: TLabel;
    LabelIN: TLabel;
  protected
    procedure ReadRS; //Yhden laskuaskeleen su
    //Perit.luokan Execute korvataan omalla
    procedure Execute; override;
  public
    //Rakentaja, joka alustaa mm. sis. muut.
    constructor Create(ilabel,hLabel:TLabel);
  end;


type
  TFormCommTest = class(TForm)
    ButtonDTRon: TButton;
    ButtonDTRoff: TButton;
    ButtonSend: TButton;
    EditSend: TEdit;
    LabelIN: TLabel;
    TimerIn: TTimer;
    MSComm1: TMSComm;
    ButtonSendComm: TButton;
    LabelCRC: TLabel;
    Label1: TLabel;
    GroupBox1: TGroupBox;
    LabelComPort: TLabel;
    LabelIO: TLabel;
    CheckBoxSThreshold: TCheckBox;
    CheckBoxRTHreshold: TCheckBox;
    ComboBoxBaud: TComboBox;
    EditIO: TEdit;
    ComboBoxComPort: TComboBox;
    ButtonSet: TButton;
    CheckBoxTimerIn: TCheckBox;
    LabelInHex: TLabel;
    ButtonHex: TButton;
    EditHex: TEdit;
    ButtonClear: TButton;
    procedure ButtonDTRonClick(Sender: TObject);
    procedure ButtonDTRoffClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ButtonSendClick(Sender: TObject);
    procedure TimerInTimer(Sender: TObject);
    procedure ButtonSetClick(Sender: TObject);
    procedure ComboBoxComPortChange(Sender: TObject);
    procedure MSComm1OnComm(Sender: TObject);
    procedure ButtonSendCommClick(Sender: TObject);
    procedure ButtonHexClick(Sender: TObject);
    procedure ButtonClearClick(Sender: TObject);
  private
    { Private declarations }
    sendchars : array [1..500] of char;
    sendcount : integer;
    LueRS : cLueRS;
    procedure DoSetLine;
    function CountCRC(s:string):string;
    function CountCRCDisp(var s:Array of char; n:integer):integer;
  public
    { Public declarations }
  end;



var
  FormCommTest: TFormCommTest;

implementation

{$R *.DFM}

var   getcount : integer;


var BaseAddr : word;
    DivideLatchLSB,
    DivideLatchMSB,
    TransmitBuffer,
    ReceiveBuffer,
    InterruptEnableReg,
    InterruptIdentificationRegister,
    LineControlRegister,
    ModemControlRegister,
    LineStatusRegister,
    ModemStatusRegister : Word;

procedure DTRon; assembler;
asm
  mov dx,ModemControlRegister
  in  al,dx
  or  al,1
  mov al,1
  out dx,al
end;

procedure DTRoff;
asm
  mov dx,ModemControlRegister
  in  al,dx
  and al,$fe
  mov al,0
  out dx,al
end;

procedure TFormCommTest.ButtonDTRonClick(Sender: TObject);
begin
  DTRon;
end;

procedure TFormCommTest.ButtonDTRoffClick(Sender: TObject);
begin
  DTRoff;
end;

procedure SetBase(Base:Word);
begin
  BaseAddr                          := Base;
  DivideLatchLSB                    := Base + 0;
  DivideLatchMSB                    := Base + 1;
  TransmitBuffer                    := Base + 0;
  ReceiveBuffer                     := Base + 0;
  InterruptEnableReg                := Base + 1;
  InterruptIdentificationRegister   := Base + 2;
  LineControlRegister               := Base + 3;
  ModemControlRegister              := Base + 4;
  LineStatusRegister                := Base + 5;
  ModemStatusRegister               := Base + 6;
end;

procedure SetBaud(baud:integer);
asm
// CLI
 MOV  ECX,baud
 MOV  DX,LineControlRegister
 MOV  AL,$80          // divisor latch access on
 OUT  DX,AL
// MOV  DX,$1
 MOV  EAX,$1C200      // (1.8432Mhz/16) = 1C200H
 MOV  EDX,0
 DIV  ECX
 MOV  DX,DivideLatchLSB
 OUT  DX,AL
 MOV  DX,DivideLatchMSB
 MOV  AL,AH
 OUT  DX,AL
 MOV  DX,LineControlRegister                  //  0  0 000 0 11
 MOV  AL,$03            // divisor latch access off +    n,1,8
 OUT  DX,AL

 STI
end;

procedure SendChar(c:char);
label odota_linja_vapaaksi,odota_linja_vapaaksi2;
asm
 MOV  AL,c
 PUSH AX
 MOV  EDX,0
 MOV  DX,LineStatusRegister
odota_linja_vapaaksi:
 IN   AL,DX
 TEST AL,$20                 // THR empty jos bitti 5 pll
 JZ   odota_linja_vapaaksi
 POP  AX
 MOV  DX,TransmitBuffer      // Transmitter holding register
 OUT  DX,AL

 MOV  DX,LineStatusRegister
odota_linja_vapaaksi2:
 IN   AL,DX
 TEST AL,$40                 // TxE empty jos bitti 5 pll
 JZ   odota_linja_vapaaksi2
end;

procedure WaitSend;
label odota_linja_vapaaksi2;
asm
 MOV  EDX,0
 MOV  DX,LineStatusRegister
odota_linja_vapaaksi2:
 IN   AL,DX
 TEST AL,$40                 // TxE empty jos bitti 5 pll
 JZ   odota_linja_vapaaksi2
end;

Function ReadChar : smallint;
Label loppu;
asm
  MOV  AX,-1
  MOV  DX,LineStatusRegister
  IN   AL,DX
  AND  AL,1
  JZ   loppu
  MOV  DX,ReceiveBuffer
  MOV  AX,0
  IN   AL,DX
loppu:
  MOV  Result, AX
end;

procedure SendString(var s:array of char; n:integer);
var i:integer;
begin
  DTRon;
  for i:=0 to n-1 do
    SendChar(s[i]);
  DTRoff;
end;

procedure SetLine(const io,b:string);
var base,baud:integer;
begin
  base := StrToInt('$'+io);
  SetBase(base);
  baud := StrToInt(b);
  SetBaud(baud);
end;

procedure TFormCommTest.DoSetLine;
var base,baud:integer; i:integer;
begin
  if ( MSComm1.PortOpen ) then MSComm1.PortOpen := False;
  MSComm1.CommPort := StrToInt(ComboBoxComPort.Text);
  SetLine(EditIO.Text,ComboBoxBaud.Text);
  if ( CheckBoxRThreshold.Checked ) then i := 1 else i := 0;
  MSComm1.RThreshold := i;
  if ( CheckBoxSThreshold.Checked ) then i := 1 else i := 0;
  MSComm1.SThreshold := i;
  TimerIn.Enabled := CheckBoxTimerIn.Checked;
  MSComm1.PortOpen := True;

  if ( LueRS = NIL ) then LueRS := cLueRS.Create(LabelIN,LabelInHex);

end;

procedure TFormCommTest.FormCreate(Sender: TObject);
var p:integer;
begin
  LueRS := NIL;
  ComboBoxBaud.ItemIndex    := 13;  // 9600
  p := 0;
  if ( ParamStr(1) > ' ' ) then p := ORD(ParamStr(1)[1]) - ORD('1');
  ComboBoxComPort.ItemIndex :=  p;  // Com 1
  ComboBoxComPortChange(self);
  DoSetLine;

end;

function crc16_2(puchMsg:PChar;usDataLen:integer):word;
  stdcall; far; external;
{$l crc.obj}

function TFormCommTest.CountCRC(s:string):string;
var  crc : integer;
begin
  crc := crc16_2(PChar(s),Length(s));
  LabelCRC.Caption := Format('%04x',[crc]);
  Result := Char(lo(crc))+Char(hi(crc));
end;

function CountCRCInt(var s:Array of char; n:integer):integer;
var  crc : integer;
begin
  crc := crc16_2(s,n);
  Result := crc;
end;

function TFormCommTest.CountCRCDisp(var s:Array of char; n:integer):integer;
var  crc : integer;
begin
  crc := CountCRCInt(s,n);
  LabelCRC.Caption := Format('%04x',[crc]);
  Result := crc;
end;

procedure TFormCommTest.ButtonSendClick(Sender: TObject);
begin
  CountCRCDisp(SendChars,SendCount);
  SendString(SendChars,SendCount);
  LabelIn.Caption := '';
  LabelInHex.Caption := '';
  GetCount := 0;
end;

function CharToHex(c:char):string;
begin
  Result := Format('%02x',[Ord(c)]);
  if ( Result[1] = ' ' ) then Result[1] := '0';
end;

procedure TFormCommTest.TimerInTimer(Sender: TObject);
var i:smallint; c:Char; st:string;
begin
  while ( true ) do begin
    i := ReadChar;
    if ( hi(i) <> 0 ) then exit;
    c := Char(lo(i));
    if ( GetCount >= 30 ) then begin
      st := LabelInHex.Caption;
      delete(st,1,3*20);
      LabelInHex.Caption := st;
      LabelIn.Caption := '';
      GetCount := 10;
    end;
    LabelIn.Caption := LabelIn.Caption + c;
    LabelInHex.Caption := LabelInHex.Caption + CharToHex(c) + ' ';
    Inc(GetCount);
  end;
end;

procedure TFormCommTest.ButtonSetClick(Sender: TObject);
begin
  DoSetLine;
end;

procedure TFormCommTest.ComboBoxComPortChange(Sender: TObject);
begin
  case ComboBoxComPort.Text[1] of
    '1' : EditIO.Text := '3f8';
    '2' : EditIO.Text := '2f8';
    '3' : EditIO.Text := '3e8';
    '4' : EditIO.Text := '2e8';
  end;
end;

procedure TFormCommTest.MSComm1OnComm(Sender: TObject);
begin
  case MSComm1.CommEvent of
   // Errors
    comBreak:  ; // A Break was received.
                // Code to handle a BREAK goes here.
    comCDTO:   ;	// CD (RLSD) Timeout.
    comCTSTO:  ;	// CTS Timeout.
    comDSRTO:  ;	// DSR Timeout.
    comFrame:  ;	// Framing Error
    comOverrun:	;       // Data Lost.
    comRxOver:	;       // Receive buffer overflow.
    comRxParity: ;	// Parity Error.
    comTxFull:	;       // Transmit buffer full.
  // Events
    comEvCD:	;       // Change in the CD line.
    comEvCTS:	;       // Change in the CTS line.
    comEvDSR:	;       // Change in the DSR line.

    comEvRing:	;       // Change in the Ring Indicator.
    comEvReceive:  	// Received RThreshold # of chars.
      LabelIn.Caption := LabelIn.Caption + MSComm1.Input;
      
    comEvSend:	// There are SThreshold number of
               // characters in the transmit buffer.
      begin
            DTRoff;
//            DoSetLine;
      end;
  End;
end;

procedure TFormCommTest.ButtonSendCommClick(Sender: TObject);
begin
  DTRon;
  CountCRC(EditSend.Text);
  MSComm1.Output := EditSend.Text;
  LabelIn.Caption := '';
  if ( MSComm1.SThreshold = 0 ) then begin
    WaitSend;
    DTRoff;
//    DoSetLine;
  end;
end;

procedure TFormCommTest.ButtonHexClick(Sender: TObject);
var s,r,h:string; crc,len,i:integer;
begin
  s := EditHex.text;
  len := Length(EditHex.text);
  r := '';
  i := 1;
  sendcount := 0;
  while ( i < len ) do begin
    if ( Pos(s[i],'$ ,;/|') > 0 ) then begin i := i + 1; continue; end;
    h := '$' + s[i] + s[i+1]; i := i + 2;
    r := r + Char(StrToInt(h));
    inc(sendcount); sendchars[sendcount] := Char(StrToInt(h));
  end;
  EditSend.Text := r + CountCrc(r);
  crc := CountCrcInt(sendchars,sendcount);
  inc(sendcount); sendchars[sendcount] := Char(lo(crc));
  inc(sendcount); sendchars[sendcount] := Char(hi(crc));
end;

procedure TFormCommTest.ButtonClearClick(Sender: TObject);
begin
  LabelIn.Caption := '';
  LabelInHex.Caption := '';
  GetCount := 0;
end;


procedure cLueRS.ReadRS;
var i:smallint; c:Char; st:string;
begin
  while ( true ) do begin
    i := ReadChar;
    if ( hi(i) <> 0 ) then exit;
    c := Char(lo(i));
    if ( GetCount >= 30 ) then begin
      st := LabelInHex.Caption;
      delete(st,1,3*20);
      LabelInHex.Caption := st;
      LabelIn.Caption := '';
      GetCount := 10;
    end;
    LabelIn.Caption := LabelIn.Caption + c;
    LabelInHex.Caption := LabelInHex.Caption + CharToHex(c) + ' ';
    Inc(GetCount);
  end;
end;

//-------------------------------------------
procedure cLueRS.Execute;
// Tm suorittaa varsinaisen sikeen
// toimenpiteet.  Kun tm metodi loppuu,
// pyshtyy sie.  Sie hvi autom.
// jos FreeOnTerminate := True
begin
  while ( true ) do begin
    if terminated then begin
      Break;
    end;
    ReadRS;
  end;
end;

//-------------------------------------------
constructor cLueRS.Create(ilabel,hLabel:TLabel);
begin
  inherited Create(False);
  LabelIN    := iLabel;
  LabelInHex := hlabel;
  FreeOnTerminate := True;
end;




end.
