unit YasForm;
{
   Author:  Vesa Lappalainen
   Date:    30.12.1996
   Changes: 11.01.1997
              + leds
   Missing:
              -- Run command by bitfield param
              -- editing bitparams
              -- reading Leds from ini-file
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  KParams, StdCtrls, ExtCtrls, kComp, ComCtrls, kbar, KYasPar, KModbus,
  KButtons, KParam, Gauges, kRndled, savepos;

const MAXVALUES=3;
const SMAX = 5;
const MMAX = 1;

type PTForm = ^TForm;

type
  TValueBar = class (TObject)
  public
    v:TkParam;
    b:TGauge;
    max:double;
    maxi:integer;
    vali:integer;
    procedure SetValue(d:double);
    property Value:double write SetValue;
  end;

type
  TFormYas = class(TForm)
    GroupBox1: TGroupBox;
    kTrackBarHz: TkTrackBar;
    Panel1: TPanel;
    Label4: TLabel;
    LabelPort: TLabel;
    ButtonParams: TButton;
    BYasBack: TkSpeedButton;
    BYasFwd: TkSpeedButton;
    BYasRun: TkSpeedButton;
    CounterMin: TCounter;
    CounterMax: TCounter;
    Label0: TLabel;
    CounterHz: TkParam;
    TimerRead: TTimer;
    Panel2: TPanel;
    kParamFreq: TkParam;
    GaugeFreq: TGauge;
    kParamCurA: TkParam;
    kParamOutV: TkParam;
    GaugeCurA: TGauge;
    GaugeOutV: TGauge;
    GaugeRef: TGauge;
    kParamRef: TkParam;
    GroupBox2: TGroupBox;
    CheckBoxMAMC: TCheckBox;
    CheckBoxM1M2: TCheckBox;
    GroupBox3: TGroupBox;
    CheckBoxS1: TCheckBox;
    CheckBoxS2: TCheckBox;
    CheckBoxS3: TCheckBox;
    CheckBoxS4: TCheckBox;
    CheckBoxS5: TCheckBox;
    CheckBoxS6: TCheckBox;
    LedS1: TkRndLed;
    LedS5: TkRndLed;
    LedS4: TkRndLed;
    LedS2: TkRndLed;
    LedS3: TkRndLed;
    LedS6: TkRndLed;
    LedMA: TkRndLed;
    LedM1: TkRndLed;
    ButtonOK: TButton;         EditS1: TEdit;         EditS2: TEdit;                                EditS3: TEdit;                                                       EditS4: TEdit;                                                                                                     EditS5: TEdit;
    EditMA: TEdit;                                                                                                                                                                         EditS6: TEdit;
    EditM1: TEdit;
    GroupBoxFault: TGroupBox;
    LedFault: TkRndLed;
    CBReset: TCheckBox;
    CheckBoxUpdate: TCheckBox;
    ButtonShowCom: TButton;
    ParamSlave: TkParam;
    SavePos1: TSavePos;
    procedure FormCreate(Sender: TObject);
    procedure ButtonParamsClick(Sender: TObject);
    procedure kTrackBarHzChange(Sender: TObject); virtual;
    procedure CounterHzClick(Sender: TObject); virtual;
    procedure BYasStopClick(Sender: TObject);
    procedure SetHz(hz:double; run:boolean);
    procedure Stop;
    procedure UpdateMinMax;
    procedure CheckButtons(Sender: TObject; down:boolean);
    procedure BYasFwdMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BYasBackMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BYasRunMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BYasRunMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure kParamFreqClick(Sender: TObject);
    procedure TimerReadTimer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CreateValues;
    procedure UpdateValues;
    procedure CheckBoxMAMCClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure CheckBoxS1Click(Sender: TObject);
    procedure ButtonOKClick(Sender: TObject);
    procedure ReadIni;
    procedure WriteIni;
    procedure EditS1Change(Sender: TObject);
    procedure CBResetClick(Sender: TObject);
    procedure CheckBoxUpdateClick(Sender: TObject);
    procedure ButtonShowComClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    function ParamSlaveAfterAsk(Sender: TObject; var val: Double): Boolean;
  private
    params:TYasParams;
    formptr : PTForm;
    Changes : integer;
    values : array [0..MAXVALUES] of TValueBar;
    OutWIndex : integer;
    InWIndex : integer;
    OutRIndex : integer;
    InRIndex : integer;
    CBoxS : array [0..SMAX] of TCheckBox;
    LedsS : array [0..SMAX] of TkRndLed;
    EditS : array [0..SMAX] of TEdit;
    CBoxM : array [0..MMAX] of TCheckBox;
    LedsM : array [0..MMAX] of TkRndLed;
    EditM : array [0..MMAX] of TEdit;
  protected
    function GetValueIni:string; virtual;
  public
    procedure Loaded; override;
    constructor Create2(form:PTForm; par:TYasParams);
    property ValueIni:string read GetValueIni;
  end;


implementation
  uses IniFiles;

{$R *.DFM}
procedure TValueBar.SetValue(d:double);
begin
  if ( v <> NIL ) then v.Value := d;
  if ( max <= 0 ) or ( b = NIL ) then exit;
  b.Progress := round(d*100.0/max);
end;

function TFormYas.GetValueIni:string;
begin
  Result := Params.ValueIniName;
end;

procedure TFormYas.ReadIni;
var i:integer;
    Ini : TIniFile;
begin
  for i:=0 to SMAX do with LedsS[i] do begin IniName := ValueIni; ReadInifile; end;
  for i:=0 to MMAX do with LedsM[i] do begin IniName := ValueIni; ReadInifile; end;
  LedFault.IniName := ValueIni; LedFault.ReadInifile;

  Ini := TIniFile.Create(Valueini);
  for i:=0 to SMAX do
    EditS[i].Text := Ini.ReadString('ContactNames',CBoxS[i].Caption,EditS[i].Text);
  for i:=0 to MMAX do
    EditM[i].Text := Ini.ReadString('ContactNames',CBoxM[i].Caption,EditM[i].Text);
  Ini.Free;
end;

procedure TFormYas.WriteIni;
var i:integer;
    Ini : TIniFIle;
begin
  Ini := TIniFile.Create(Valueini);
  for i:=0 to SMAX do
    Ini.WriteString('ContactNames',CBoxS[i].Caption,EditS[i].Text);
  for i:=0 to MMAX do
    Ini.WriteString('ContactNames',CBoxM[i].Caption,EditM[i].Text);
  Ini.Free;
end;

procedure TFormYas.CreateValues;
var i:integer;
begin
  for i:=0 to MAXVALUES do
    values[i] := TValueBar.Create;

  values[0].v := kParamFreq;
  values[0].b := GaugeFreq;
  values[0].max := 100;
  values[0].maxi := -1;
  values[0].vali := params.GetIndex('r036');

  values[1].v := kParamCurA;
  values[1].b := GaugeCurA;
  values[1].max := 100;
  values[1].maxi := params.GetIndex('n032');
  values[1].vali := params.GetIndex('r039');

  values[2].v := kParamOutV;
  values[2].b := GaugeOutV;
  values[2].max := 100;
  values[2].maxi := params.GetIndex('n013');
  values[2].vali := params.GetIndex('r040');

  values[3].v := kParamRef;
  values[3].b := GaugeRef;
  values[3].max := 100;
  values[3].maxi := -1;
  values[3].vali := params.GetIndex('r035');

  CBoxS[0] := CheckBoxS1;      LedsS[0] := LedS1;   EditS[0] := EditS1;
  CBoxS[1] := CheckBoxS2;      LedsS[1] := LedS2;   EditS[1] := EditS2;
  CBoxS[2] := CheckBoxS3;      LedsS[2] := LedS3;   EditS[2] := EditS3;
  CBoxS[3] := CheckBoxS4;      LedsS[3] := LedS4;   EditS[3] := EditS4;
  CBoxS[4] := CheckBoxS5;      LedsS[4] := LedS5;   EditS[4] := EditS5;
  CBoxS[5] := CheckBoxS6;      LedsS[5] := LedS6;   EditS[5] := EditS6;

  CBoxM[0] := CheckBoxMAMC;    LedsM[0] := LedMA;   EditM[0] := EditMA;
  CBoxM[1] := CheckBoxM1M2;    LedsM[1] := LedM1;   EditM[1] := EditM1;

  ReadIni();
end;

procedure TFormYas.UpdateMinMax;
begin
  CounterMax.Value := params.ReadMaxHz;
  CounterMin.Value := -CounterMax.Value;
  kTrackBarHz.Max := trunc(CounterMax.Value*10);
  kTrackBarHz.Min := trunc(CounterMin.Value*10);
  values[0].max := abs(CounterHz.Value);
  values[1].max := params.Value(values[1].maxi);
  values[2].max := params.Value(values[2].maxi);
  values[3].max := CounterMax.Value;
end;

procedure TFormYas.UpdateValues;
var bits,i:integer;
begin
  values[0].max := abs(CounterHz.Value);
  for i:=0 to MAXVALUES do
    values[i].SetValue(params.ReadValue(values[i].vali));

  bits := Round(params.ReadValue(InWIndex));
  CBReset.Checked := ( bits and 8 ) <> 0;
  bits := bits shr 4;
  for i:=2 to SMAX do begin
    CBoxS[i].Checked := ( bits and 1 ) = 1;
    bits := bits shr 1;
  end;

  bits := Round(params.ReadValue(InRIndex));
  for i:=0 to SMAX do begin
    LedsS[i].LedOn := ( bits and 1 ) = 1;
    bits := bits shr 1;
  end;

  bits := Round(params.ReadValue(OutWIndex));
  for i:=0 to MMAX do begin
    CBoxM[i].Checked := ( bits and 1 ) = 1;
    bits := bits shr 1;
  end;

  bits := Round(params.ReadValue(OutRIndex));
  LedFault.LedOn := ( bits and 8 ) <> 0;
  bits := bits shr 5;
  for i:=0 to MMAX do begin
    LedsM[i].LedOn := ( bits and 1 ) = 1;
    bits := bits shr 1;
  end;
end;

procedure TFormYas.FormDestroy(Sender: TObject);
var i:integer;
begin
  formptr^ := NIL;
  if  ( Changes > 0 ) then WriteIni;
  for i:=0 to MAXVALUES do
    values[i].free;
end;

procedure TFormYas.FormCreate(Sender: TObject);
begin
  TimerRead.Enabled := false;
  Changes := 0;



  LabelPort.Caption := IntToStr(Params.Modbus.Port);
//  Top := 0;
//  Left := 0;

  CreateValues;
  UpdateMinMax;
  InWIndex  := params.GetIndex('r001');
  OutWIndex := params.GetIndex('r009');
  InRIndex  := params.GetIndex('r043');
  OutRIndex := params.GetIndex('r032');
  TimerRead.Enabled := CheckBoxUpdate.Checked;
end;


procedure TFormYas.ButtonParamsClick(Sender: TObject);
begin
  params.Edit;
end;

procedure TFormYas.SetHz(hz:double; run:boolean);
begin
  if ( run ) then
    hz := params.WriteReadHz(hz)
  else begin params.WriteHz(hz);  hz := params.ReadHz; end;
  CounterHZ.Value := hz;
  kTrackBarHz.Position := trunc(-hz*10);
end;

procedure TFormYas.kTrackBarHzChange(Sender: TObject);
var hz:double;
begin
  with ( Sender as TkTrackBar ) do hz := -Position/10.0;
  SetHz(hz,BYasRun.Down);
end;

procedure TFormYas.CounterHzClick(Sender: TObject);
begin
  UpdateMinMax;
  CounterHz.MaxValue := CounterMax.Value;
  CounterHz.MinValue := CounterMin.Value;
  CounterHz.Ask;
  SetHz(CounterHz.Value,BYasRun.Down);
end;

procedure TFormYas.Stop;
begin
  Params.Stop;
  BYasRun.Down := false;
  BYasBack.Down := false;
  BYasFwd.Down := false;
end;

procedure TFormYas.BYasStopClick(Sender: TObject);
begin
  Stop;
end;

procedure TFormYas.CheckButtons(Sender: TObject; down:boolean);
begin
  if ( ( Sender = BYasBack ) and BYasRun.Down )  or
     ( ( Sender = BYasFwd  ) and BYasRun.Down ) then begin
    Stop;
    Exit;
  end;

  if ( Sender = BYasBack ) and down then
    SetHZ(-abs(CounterHZ.Value),true)
  else if ( Sender = BYasFwd ) and down then
    SetHZ(abs(CounterHZ.Value),true)
  else begin
    params.stop;
    SetHZ(CounterHZ.Value,false);
  end;
end;

procedure TFormYas.BYasFwdMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  CheckButtons(Sender,true);
end;

procedure TFormYas.BYasBackMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  CheckButtons(Sender,false);
end;

procedure TFormYas.BYasRunMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if ( not BYasRun.Down ) then SetHz(CounterHZ.Value,true);
end;

procedure TFormYas.BYasRunMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if ( BYasRun.Down ) then begin
    Params.Stop;
    SetHz(CounterHZ.Value,false);
  end;
end;

procedure TFormYas.kParamFreqClick(Sender: TObject);
begin
  //
end;

procedure TFormYas.TimerReadTimer(Sender: TObject);
begin
  TimerRead.Enabled := false;
  UpdateValues;
  TimerRead.Enabled := true;
end;

procedure TFormYas.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  TimerRead.Enabled := false;
  Stop;
  if ( FormPtr <> NIL ) then FormPtr^ := NIL;
  Release;
end;

procedure TFormYas.CheckBoxMAMCClick(Sender: TObject);
var cb:TCheckBox;
begin
  cb := Sender as TCheckBox;
  params.WriteBit(OutWIndex,cb.tag,cb.Checked);
end;

procedure TFormYas.CheckBoxS1Click(Sender: TObject);
var cb:TCheckBox;
begin
  cb := Sender as TCheckBox;
  params.WriteBit(InWIndex,cb.tag,cb.Checked);
end;

procedure TFormYas.ButtonOKClick(Sender: TObject);
begin
  Close;
end;

procedure TFormYas.EditS1Change(Sender: TObject);
begin
  Inc(Changes);
end;

procedure TFormYas.CBResetClick(Sender: TObject);
begin
//  params.WriteValue(InWIndex,8*Ord((Sender as TCheckBox).Checked));
  params.Reset;
  (Sender as TCheckBox).Checked := false;
end;

procedure TFormYas.CheckBoxUpdateClick(Sender: TObject);
begin
  TimerRead.Enabled := (Sender as TCheckBox).Checked;
end;

procedure TFormYas.Loaded;
begin
  Name := 'FormYas'+Params.FormName;
  Caption := Params.FormName;
end;

constructor TFormYas.Create2(form:PTForm; par:TYasParams);
begin
  Params := par;
  formptr := form;
  inherited Create(NIL);
  Params.Slave := trunc(ParamSlave.Value);
end;


procedure TFormYas.ButtonShowComClick(Sender: TObject);
begin
  Params.ShowErrors;
end;

procedure TFormYas.FormShow(Sender: TObject);
begin
  TimerRead.Enabled := CheckBoxUpdate.Checked;
end;

function TFormYas.ParamSlaveAfterAsk(Sender: TObject;
  var val: Double): Boolean;
begin
  Params.Slave := Trunc(val);
  Result := true;
end;

end.
